/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Seokman Paul Han
 * Student ID: 9832185
 * Section:    BB
 *	
 * STARTER PROGRAM
 *
 * To start with, your job is to figure out how this program works.
 *
 * Greeting Card Designer (Ultimate version)
 *
 *  The GP142 graphics window shows some buttons and the inside
 *  or outside (cover) of a greeting card.  The idea is that you 
 *  can design what you want to card to look like by adding and moving
 *  objects: 
 *    messages, message color and position
 *    shapes,   shape color and position
 *
 *   To place a message or a greeting, you click on an appropriate button, and 
 *   then you can click on the desired position in the card.  
 
 *	 In this starter version, you can do much less.
 *   You can change the card background, place one shape on the card,
 *   and change the shape back and forth between two possible kinds.
 */

#include "gp142.h"
#include <math.h>
#include <time.h>

	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/*
 * The state, or status you are in determines what happens when you click 
 * the card:
 * ADD SHAPE   -- you click the card, and a new object is placed there.
 *                You get into this mode by clicking an ADD button.
 *                After doing an ADD, you are put into SELECTED mode.
 * SELECTED    -- An object is selected. In this mode, the type 
 *                rotation applies to thecurrent object.
 */
/* Hint: you may need to add statuses when you make the program more complex.*/
#define STATUS_NOTHING   1
#define STATUS_ADD_SHAPE 2
#define STATUS_SELECTED  3
#define STATUS_ADD_MSG   4
#define STATUS_SELECT    5
#define STATUS_NOMORE    6
#define STATUS_DELETE    7

/* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	9
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL   0
#define NOFILL 1

/* Types of objects we support.  (Perhaps not all types are used yet.)*/
#define OBJECT_NONE    0
#define OBJECT_SHAPE   1
#define OBJECT_MSG     2

/*if you add new types, you may need to change this*/
#define MAX_SHAPES      5
#define FIRST_SHAPE_NUM 0
#define MAX_MSG         5
#define FIRST_MSG_NUM   0

/* These are the kinds of shapes we support.  You'll need to add more. */
#define SHAPE_HEART  0
#define SHAPE_STAR   1
#define SHAPE_FACE   2
#define SHAPE_TRIN   3
#define SHAPE_RIBBON 4

/* These are the messages */
#define MSG_BEMINE   0
#define MSG_TRUELUV  1
#define MSG_BEMYV    2
#define MSG_SWEETIE  3
#define MSG_LUVU     4

/* Hint: once you understand how these shape types are used, you may decide
 * to do something similar with messages
 */

/*Possible places for mouse clicks*/
#define CLICK_BUTTON  1   /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD    2   /* You clicked in the card area */
#define CLICK_OUTSIDE 3	  /* You clicked outside the card area, not on a button*/	

#define MAX_OBJECT  50    /* This is the maximum number of object */
/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int object_count, 
			   int object_type[], int object_num[], 
			   int object_color[], int object_x[], int object_y[]);
void DrawShape(int color, int shape_type, int bottom_x, int bottom_y);
void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawFace (int x, int y, int color);
void DrawTrin (int x, int y, int color);
void DrawRibbon (int x, int y, int color);
void DrawMsg (int msg_type, int color, int x, int y);
/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[], 
					  int object_num[], int object_color[], 
					  int object_x[], int object_y[],int *last_button,
					  int *selected_object);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type[], int object_num[],
				  int *last_button, int object_color[], int *selected_object);

/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *object_count, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *selected_object);
void AddMsg(int x, int y, int *status, int *object_count, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *selected_object);
void ChangeLocation(int x, int y, int object_x[], int object_y[], int *selected);
void FindObject(int x, int y, int object_x[], int object_y[],
				int object_type[], int *selected_object, int *status, int *last_button);
void Delete_Object(int x, int y, int object_x[], int object_y[],
				   int object_type[], int object_num[],int object_color[],
				   int *object_count, int *selected_object, int *status, int *last_button);
void restart(int *background_color, int *object_count, int object_type[], int *status);
void confirm(int *last_button,int *quit);
void mouse_wait(void);
void opening(void);
void environment(void);
void ending(int *quit);


/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int i;
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */

	/*variables and their default values*/
	int background_color = YELLOW;
	int status = STATUS_NOTHING;
	
	/* Each object will have a number telling what kind of object it is, a color,
	 * and an x and y coordinate.  You'll need to make these into arrays so you
	 * can support more than one object.
	 */
	int object_count = 0;           /* How many objects on the page? */
	int object_type[MAX_OBJECT];
	int object_num[MAX_OBJECT];        /* If type is shape, either 
									   heart or star                 */
	int object_color[MAX_OBJECT];      /* Color of object               */
	int object_x[MAX_OBJECT];          /* Position of object            */
	int object_y[MAX_OBJECT];
	
	int last_button = -1;           /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */
	int event; /*the most recent GP142 event*/
	int selected_object = -1;
	
	time_t t; /*needed only when initializing a random number generator*/

	for (i=0;i<MAX_OBJECT;i++)
		object_type[i] = OBJECT_NONE;  /* Can also be a shape           */
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is 
							   something you should do if you plan to use 
							   random numbers. Leave it here in your program 
							   and forget about it.*/
	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	opening();
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, object_count, 
			      object_type, object_num, object_color, object_x, object_y);
		DrawButtons(last_button);	  /* Show the buttons...*/ 
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

		if (last_button == 8) 
			confirm(&last_button,&quit);
		

		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*not needed for this program. Use this if user will need to 
			  hit a key. Note that scanf CANNOT be used with GP142.  If you 
			  use this, the key character value is in variable "key_hit"*/
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &object_count, object_type, 
							 object_num, object_color, 
							 object_x, object_y,
							 &last_button,&selected_object);			
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed,*/
			/*not currently used in the program*/		
			break;

		default:
			
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

	GP142_printfXY(RED,
		-GP142_XMAX + 147,
		GP142_YMAX - 40, 25,
		"Your Personal Greeting Card Designer");

} /*end DrawBlankScreen */


/* 
 * Draws the buttons 
 */
void DrawButtons(int last_button)
{
/* To add buttons, you'll need to change the #defined constant NUM_BUTTONS
 * and add messages to this array.  Although we haven't covered 2-D arrays
 * yet, you should be able to play with this enough to get it going.
 * Look at course packet, page N-25, for a similar example.
 */
	char b_labels [NUM_BUTTONS][25] = {
		"Background color",
			"Object color",
			"Next, please",
			"Add message",
			"Add shape",
			"Select object",
			"Delete object",
			"Restart",
			"PRINT",
	};
	
	int i, text_offset = -GP142_XMAX + 10, font_size = 12;
	int y, label_y;

	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 2,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, 1);
		
		/* this will draw button is not pressed */
		GP142_lineXY(BLACK,
			-GP142_XMAX + 5,
			y - BUTTON_HEIGHT - 1,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 1,2);
		GP142_lineXY(BLACK,
			-GP142_XMAX + BUTTON_WIDTH - 1,
			y - 3,
			-GP142_XMAX + BUTTON_WIDTH - 1,
			y - BUTTON_HEIGHT - 2,2);
		
		
		label_y = y - BUTTON_HEIGHT/2 - 7;
		if (i == 8){
			if (last_button == 8)
				GP142_printfXY(SELECTED_COLOR, text_offset, label_y - 9, font_size + 14, b_labels[i]);
			else
				GP142_printfXY(BLACK, text_offset, label_y - 9, font_size + 14, b_labels[i]);	
		}
		else{
			if (i == last_button)
				GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size, b_labels[i]);
			else
				GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
		}
	}	
}


/*
 * Render (draw) the page and all its contents.
 */
void DrawCard (int background_color, int status, int object_count, 
			   int object_type[], int object_num[], 
			   int object_color[], int object_x[], int object_y[])
{
	int font_size = 24;
	int i;

	/*
	 * Draw the background of the card.
	 */
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	/* 
	 * Draw a shape or message on the card, if one currently exists.
	 */
	for(i=0;i<object_count;i++){
		if (object_type[i] == OBJECT_SHAPE)
			DrawShape (object_num[i], object_color[i], object_x[i], object_y[i]);	
		else
			DrawMsg (object_num[i], object_color[i], object_x[i], object_y[i]);
	}
	/*
	 * Write an appropriate status message below the background
	 */
	switch (status) {
	case STATUS_NOTHING:
		GP142_printfXY (GREEN, PAGE_LLX + 40, PAGE_LLY-60, font_size,
			"Click buttons you wish to do");
		break;
	case STATUS_ADD_SHAPE:
		GP142_printfXY (RED, PAGE_LLX + 26, PAGE_LLY-60, font_size,
			"Click on the card to add a shape");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (BLACK, PAGE_LLX - 25, PAGE_LLY-40, font_size,
			"Object selected. Click on the card to locate");
		GP142_printfXY (BLACK, PAGE_LLX + 23, PAGE_LLY-65, font_size,
			"Or Click Next Button to change");
		GP142_printfXY (BLACK, PAGE_LLX - 5, PAGE_LLY-90, font_size,
			"Or Click Object Color to change color");
		break;
	case STATUS_ADD_MSG:
		GP142_printfXY (RED, PAGE_LLX + 12, PAGE_LLY-60, font_size,
			"Click on the card to add a message");
		break;
	case STATUS_SELECT:
		GP142_printfXY (PURPLE, PAGE_LLX - 18, PAGE_LLY-60, font_size,
			"To select an object, click close to its origin");
		break;
	case STATUS_NOMORE:
		GP142_printfXY (GREEN, PAGE_LLX + 40, PAGE_LLY-60, font_size,
			"No more object can be added");
		break;
	case STATUS_DELETE:
		GP142_printfXY(RED, PAGE_LLX - 18, PAGE_LLY - 60, font_size,
			"To delete an object, click close to its origin");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-60, font_size,
			"Status error -- notify programmer");
		break;
	} /*end switch */
	
	
} /*end DrawPage */


/*
 * Draw one shape.
 */
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y) {

	switch ((shape_type - FIRST_SHAPE_NUM) % MAX_SHAPES) {
	case SHAPE_HEART:
		DrawHeart (bottom_x, bottom_y, color);
		break;
	case SHAPE_STAR:
		DrawStar (bottom_x, bottom_y, color);
		break;
	case SHAPE_FACE:
		DrawFace (bottom_x, bottom_y, color);
		break;
	case SHAPE_TRIN:
		DrawTrin (bottom_x, bottom_y, color);
		break;
	case SHAPE_RIBBON:
		DrawRibbon (bottom_x, bottom_y, color);
		break;
	default:
		/* Unknown shape selected */
		break;

	} /*end switch*/

}


/*
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 */
#define HEART_WIDTH 35
void DrawHeart (int x, int y, int color) {

	int h = (HEART_WIDTH/2) + (rand () %4);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5,
						x + h*2 -5, y-5,
						x, y - h*2 -5, FILL);

}


/*
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

	}
}

/* Draw a face on the card */
void DrawFace (int x, int y, int color)
{
	int eye_pos_x;
	int eye_pos_y;
	int mouth_pos;
	eye_pos_x = rand() % 3;
	eye_pos_y = rand() % 3;
	mouth_pos = rand() % 4;
	GP142_circleXY(color,x,y,20);
	GP142_circleXY(color + 1, x - 5 + eye_pos_x, 
					y + 3 + eye_pos_y, 3);
	GP142_circleXY(color + 1, x + 3 + eye_pos_x, 
					y + 3 + eye_pos_y, 3);
	GP142_triangleXY(color + 1, x - 5, y - 7,
					x + 5, y - 7,
					x, y - 7 - mouth_pos, NOFILL);
}

/*Draw two triangle on the card */
void DrawTrin (int x, int y, int color)
{
	int size;
	size = rand() % 10;
	GP142_triangleXY(color, x - 20 - size, y + 8 + size,
		x + 20 + size, y + 8 + size,
		x, y - 20 - size, 1);
	GP142_triangleXY(color, x - 20 - size, y - 8 - size,
		x + 20 + size, y - 8 - size,
		x, y + 20 + size, 1);
}

/*Draw ribbon on the card */
void DrawRibbon (int x, int y, int color)
{
	int size;
	size = rand() % 10;
	GP142_triangleXY(color, x, y, 
		x - 30 - size, y + 15 + size,
		x - 30 - size, y - 15 - size, FILL);
	GP142_triangleXY(color, x, y,
		x + 30 + size, y + 15 + size,
		x + 30 + size, y - 15 - size, FILL);
	GP142_lineXY(color, x, y,
		x - 30 - size, y - 40 - size, 1);
	GP142_lineXY(color, x, y,
		x + 30 + size, y - 40 - size, 1);
}



/* Draw the messages */
void DrawMsg (int msg_type, int color, int x, int y)
{
	int font_size;
	font_size = rand() % 5 + 12;
	switch(msg_type){
	case MSG_BEMINE:
		GP142_printfXY(color, x, y, font_size, "B MINE");
		break;
	case MSG_TRUELUV:
		GP142_printfXY(color, x, y, font_size, "TRUE LUV");
		break;
	case MSG_BEMYV:
		GP142_printfXY(color, x, y, font_size, "Be My Valentine");
		break;
	case MSG_SWEETIE:
		GP142_printfXY(color, x, y, font_size, "Sweetie Pie");
		break;
	case MSG_LUVU:
		GP142_printfXY(color, x, y, font_size, "LUV U");
		break;
	default:
		break;
	}
}





/*
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/*
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[], 
					  int object_num[], int object_color[], 
					  int object_x[], int object_y[],
					  int *last_button, int *selected_object)
{

	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			
	if (mouse_click == CLICK_BUTTON) {
				
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 object_count, object_type, object_num,last_button,
					 object_color, selected_object);
	
	}
	
	if (mouse_click == CLICK_CARD){
		if(*status == STATUS_SELECT){
			FindObject(mouse_x, mouse_y,
				object_x, object_y, object_type,
				selected_object, status, last_button);
		}
		if(*status == STATUS_DELETE){
			Delete_Object(mouse_x, mouse_y,
				object_x, object_y, object_type,
				object_num, object_color,
				object_count, selected_object, status, last_button);
		}
		if(*status == STATUS_SELECTED){
			ChangeLocation(mouse_x, mouse_y, 
				object_x, object_y, selected_object);
		}
		if(*status == STATUS_ADD_SHAPE) {
			AddShape(mouse_x, mouse_y, status, object_count, 
				object_type, object_num, object_color, 
				object_x, object_y, selected_object);
			*last_button = -1;
		}
		if(*status == STATUS_ADD_MSG){
			AddMsg(mouse_x, mouse_y, status, object_count,
				object_type, object_num, object_color,
				object_x, object_y, selected_object);
			*last_button = -1;
		}
	}
	/* Ignore any other mouse clicks */
}

/* 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_count, int object_type[], int object_num[], 
				  int *last_button, int object_color[], int *selected_object)
{
	int buttonNum = 0;
	int y_pos;


	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
					/* We know the mouse clicked in the column of buttons. Calculate
					* which one.
	*/
	buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

	/* this will make button being pressed */
	y_pos = GP142_YMAX - buttonNum * BUTTON_HEIGHT;
	GP142_lineXY(BLACK,
		-GP142_XMAX + 5,
		y_pos - 4,	
		-GP142_XMAX + BUTTON_WIDTH,
		y_pos - 4,2);
	GP142_lineXY(BLACK,
		-GP142_XMAX + 6,
		y_pos - 2,
		-GP142_XMAX + 6,
		y_pos - BUTTON_HEIGHT - 2,2);
	GP142_lineXY(WHITE,
		-GP142_XMAX + 8,
		y_pos - BUTTON_HEIGHT - 1,
		-GP142_XMAX + BUTTON_WIDTH - 1,
		y_pos - BUTTON_HEIGHT - 1,2);
	GP142_lineXY(WHITE,
		-GP142_XMAX + BUTTON_WIDTH - 1,
		y_pos - 6,
		-GP142_XMAX + BUTTON_WIDTH - 1,
		y_pos - BUTTON_HEIGHT - 2,2);
	GP142_flush();


	switch(buttonNum) {
	case 0:
		/* Change the background color */
		*background_color = (*background_color + 1) % MAX_COLORS;
		break;
	case 1:
		/* Change the object color */
		if(*object_count > 0 && *status != STATUS_NOTHING)
			object_color[*selected_object] = 
			(object_color[*selected_object] + 1) % MAX_COLORS;
		break;
	case 2:
		/* Change the type of the currently selected object */
		if(*object_count > 0 && *status != STATUS_NOTHING){
			if (object_type[*selected_object] == OBJECT_SHAPE){
				object_num[*selected_object] = 
					(object_num[*selected_object] + 1) % MAX_SHAPES;
			}
			else{
				object_num[*selected_object] =
					(object_num[*selected_object] + 1) % MAX_MSG;
			}
		}
		break;
	case 3:
		/* adding new message */
		if (*object_count == MAX_OBJECT){
			*status = STATUS_NOMORE;
		}
		else{
			*status = STATUS_ADD_MSG;
			*last_button = buttonNum;
		}
		break;
	case 4:
		/* adding new shape */
		if (*object_count == MAX_OBJECT){
			*status = STATUS_NOMORE;
		}
		else{
			*status = STATUS_ADD_SHAPE;
			*last_button = buttonNum;
		}
		break;
	case 5:
		/* selecting the object */
		if(*object_count > 0){
			*status = STATUS_SELECT;
			*last_button = buttonNum;
		}
		break;
	case 6:
		if(*object_count > 0){
			*status = STATUS_DELETE;
			*last_button = buttonNum;
		}
		break;
	case 7:
		restart(background_color, object_count, object_type, status);
		*last_button = -1;
		break;
	case 8:
		*last_button = buttonNum;
		break;
	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddShape(int x, int y, int *status, int *object_count, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *selected_object)
{
	*status = STATUS_SELECTED;
	*object_count = *object_count + 1;
	*selected_object = *object_count - 1;
	object_type[*selected_object] = OBJECT_SHAPE;
	object_num[*selected_object] = SHAPE_HEART;
	object_color[*selected_object] = RED;
	object_x[*selected_object] = x;
	object_y[*selected_object] = y;

}

/* adding a message */
void AddMsg(int x, int y, int *status, int *object_count, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *selected_object)
{
	*status = STATUS_SELECTED;
	*object_count = *object_count + 1;
	*selected_object = *object_count - 1;
	object_type[*selected_object] = OBJECT_MSG;
	object_num[*selected_object] = MSG_BEMINE;
	object_color[*selected_object] = RED;
	object_x[*selected_object] = x;
	object_y[*selected_object] = y;

}

/* change the location of object */
void ChangeLocation(int x, int y, int object_x[], int object_y[], int *selected)
{
	object_x[*selected] = x;
	object_y[*selected] = y;
}

/* find the object which is in the position of mouse */
void FindObject(int x, int y, int object_x[], int object_y[],
				int object_type[],int *selected_object, int *status, int *last_button)
{
	int i=0;
	while(object_type[i] != OBJECT_NONE){
		if ((x <= object_x[i] + 5 && x >= object_x[i] - 5)
			&& (y <= object_y[i] + 5 && y >= object_y[i] - 5)){
			*status = STATUS_SELECTED;
			*selected_object = i;
			*last_button = -1;
			break;
		}
		i = i + 1;
	}
}

/* find the object and delete it */
void Delete_Object(int x, int y, int object_x[], int object_y[],
				   int object_type[], int object_num[],int object_color[],
				   int *object_count, int *selected_object, int *status, int *last_button)
{
	int i=0;
	while(object_type[i] != OBJECT_NONE){
		if ((x <= object_x[i] + 5 && x >= object_x[i] - 5)
			&& (y <= object_y[i] + 5 && y >= object_y[i] - 5)){
			*selected_object = i;
			for (i=*selected_object;object_type[i-1] != OBJECT_NONE;i++){
				object_x[i] = object_x[i+1];
				object_y[i] = object_y[i+1];
				object_type[i] = object_type[i+1];
				object_num[i] = object_num[i+1];
				object_color[i] = object_color[i+1];
			}
			*object_count = *object_count - 1;
			*status = STATUS_NOTHING;
			*last_button = -1;
			break;
		}
		i = i + 1;
	}
}

void restart(int *background_color, int *object_count, int object_type[], int *status)
{
	int i;
	*background_color = YELLOW;
	*status = STATUS_NOTHING;
	for(i=0;i<*object_count;i++)
		object_type[i] = OBJECT_NONE;
	*object_count = 0;
}

	

/* printing obtion selected */
void confirm(int *last_button,int *quit)
{
	int i;
	int mouse_x2,mouse_y2;
	char key_hit2;
	int event;
	for (i=0;i<=110;i=i+10){
		GP142_rectangleXY(WHITE,-i*2,-i,i*2,i,FILL);
		GP142_rectangleXY(BLACK,-i*2,-i,i*2,i,NOFILL);	
		GP142_flush();
	}
	GP142_printfXY(RED, -60, 70, 25,
		"WARNING");
	GP142_printfXY(RED, -180, 30, 25,
		"DO NOT QUIT PROGRAM NOW");
	GP142_printfXY(BLACK, -190, -20, 25,
		"Do you want to print what you made?");
	GP142_rectangleXY(BLACK,-140,-90,-60,-50,NOFILL);
	GP142_lineXY(BLACK,-139,-89,-60,-89,2);
	GP142_lineXY(BLACK,-61,-90,-61,-51,2);
	GP142_rectangleXY(BLACK,60,-90,140,-50,NOFILL);
	GP142_lineXY(BLACK,61,-89,140,-89,2);
	GP142_lineXY(BLACK,139,-90,139,-51,2);
	GP142_printfXY(BLACK,-125,-83,25,"YES");
	GP142_printfXY(BLACK,83,-83,25,"NO");

	/* long expression about mouse click on the buttons */
	while (!(event == GP142_MOUSE && 
		(mouse_y2 >= -90 && mouse_y2 <= -50) &&
		((mouse_x2 >= -140 && mouse_x2 <= -60) || 
		(mouse_x2 >= 60 && mouse_x2 <= 140)))){
		event = GP142_await_event(&mouse_x2,&mouse_y2,&key_hit2);
	}
	if(mouse_x2 >= -140 && mouse_x2 <= -60){
		for(i=0;i<5;i++){
		GP142_lineXY(BLACK,-139,-52,-60,-52,2);
		GP142_lineXY(BLACK,-138,-90,-138,-51,2);
		GP142_flush();
		GP142_lineXY(WHITE,-136,-89,-61,-89,2);
		GP142_lineXY(WHITE,-61,-87,-61,-54,2);
		GP142_flush();}
	}
	else{
		for(i=0;i<5;i++){
		GP142_lineXY(BLACK,61,-52,140,-52,2);
		GP142_lineXY(BLACK,62,-90,62,-51,2);
		GP142_flush();
		GP142_lineXY(WHITE,64,-89,139,-89,2);
		GP142_lineXY(WHITE,139,-87,139,-54,2);
		GP142_flush();}
	}

	if(mouse_x2 >= -140 && mouse_x2 <= -60)
		ending(quit);
	else 
		*last_button = -1;
}

/* wating for mouse click */
void mouse_wait(void)
{
	int mouse_x,mouse_y,event;
	char key_hit;
	while (event != GP142_MOUSE)
		event = GP142_await_event(&mouse_x,&mouse_y,&key_hit);
}

/*drawing the opening screen */
void opening(void)
{
	int mouse_x, mouse_y, event;
	char key_hit;
	int i,j;
	int ten_pos = 0;
	int color;
	GP142_rectangleXY (YELLOW,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);
	GP142_printfXY(NAVY_BLUE, -210, -240, 40,
					"Click anywhere to proceed");
	GP142_printfXY(BLUE,-30,150,100,"2");
	for(j=0;j<=3;j++){
		for(i=1;i<=7;i++){
			if((i+j*7) % 7 == 0) color = RED;
			else color = BLACK;
			if(i+j*7 >= 10)
				ten_pos = 20;
			GP142_printfXY(color,-340 + 80 * i - ten_pos, 70 - j * 90,
						70, "%d",i + j * 7);
		}
	}
	for (i=1;i<=7;i++){
		GP142_lineXY(RED, -360 + 80 * i, 80,
					-290 + 80 * i, 150, 3);
		GP142_lineXY(RED, -290 + 80 * i, 80,
					-360 + 80 * i, 150, 3);
	}
	GP142_triangleXY(RED, 200, -10, 270, -10, 235, 60, 3);
	for (i=1;i<=6;i++){
		mouse_wait();
		GP142_lineXY(RED, -360 + 80 * i, -10,
					-290 + 80 * i, 60, 3);
		GP142_lineXY(RED, -290 + 80 * i, -10,
					-360 + 80 * i, 60, 3);
	}
	GP142_flush();
	mouse_wait();
	for(i=1;i<=10;i++){
		GP142_rectangleXY (BLACK,
							-GP142_XMAX, -GP142_YMAX,
							GP142_XMAX, GP142_YMAX,
							FILL);
		GP142_flush();
		GP142_rectangleXY (WHITE,
						-GP142_XMAX, -GP142_YMAX,
						GP142_XMAX, GP142_YMAX,
						FILL);
		GP142_flush();
	}
	GP142_rectangleXY (YELLOW,
						-GP142_XMAX, -GP142_YMAX,
						GP142_XMAX, GP142_YMAX,
						FILL);
	GP142_printfXY(RED,-240,0,60,
		"Valentine's DAY !!!");
	mouse_wait();
	i=0;j=0;
	while (event != GP142_MOUSE){	
		environment();
		GP142_rectangleXY(BLUE, 90, -149, 140, -49, FILL);
		GP142_rectangleXY(ICE_BLUE, 95, -85, 135, -55, FILL);
		GP142_circleXY(BLACK, -150 + i, -150, 7);
		GP142_lineXY(BLACK, -150 + i, -157, -150 + i, -187, 1);
		GP142_lineXY(BLACK, -150 + i, -187, -160 + i, -200, 1);
		GP142_lineXY(BLACK, -150 + i, -187, -140 + i, -200, 1);
		GP142_lineXY(BLACK, -162 + i, -168, -138 + i, -168, 1);
		GP142_printfXY(BLACK, -120, -250, 25,
			"What Shall I do for her?");
		if (i == 50) j = 1;
		if (i == 0) j = 0; 
		if (j == 0)
			i = i + 5;
		else
			i = i - 5;
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
	}
	environment();
	GP142_rectangleXY(BLUE, 90, -149, 140, -49, FILL);
	GP142_rectangleXY(ICE_BLUE, 95, -85, 135, -55, FILL);
	GP142_circleXY(BLACK, 115, -100, 7);
	GP142_lineXY(BLACK, 115, -107, 115, -137, 1);
	GP142_lineXY(BLACK, 115, -137, 105, -150, 1);
	GP142_lineXY(BLACK, 115, -137, 125, -150, 1);
	GP142_lineXY(BLACK, 103, -118, 128, -118, 1);
	GP142_printfXY(BLACK, -160, -250, 25,
		"YES!!! I'll make a card for her");
	GP142_lineXY(BLACK, 115, -40, 115, 0, 1);
	GP142_lineXY(BLACK, 115, -40, 100, -25, 1);
	GP142_lineXY(BLACK, 115, -40, 130, -25, 1);
	GP142_printfXY(BLACK, 65, 0, 20, "Card Maker");
	mouse_wait();
	

}

/* draw the environment such as house */
void environment(void)
{
	GP142_rectangleXY (CYAN,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);
	GP142_rectangleXY (FOREST_GREEN,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, 0,
					FILL);
	GP142_rectangleXY (BROWN,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, -150,
					FILL);
	GP142_triangleXY(SEA_GREEN,
					-100, 0, 200, 0, 50, 100, FILL);
	GP142_triangleXY(SEA_GREEN,
					0, 0, 300, 0, 150, 130, FILL);
	GP142_circleXY(WHITE, -200, 160, 50);
	GP142_circleXY(WHITE, -130, 160, 50);
	GP142_circleXY(WHITE, -60, 160, 50);
	GP142_circleXY(YELLOW, 230, 190, 30);
	GP142_rectangleXY(YELLOW, -200, -130, -100, -30, FILL);
	GP142_triangleXY(MAGENTA, -240, -30, -60, -30, -150, 50, FILL);
	GP142_rectangleXY(BROWN, -185, -150, -155, -130, FILL);
	GP142_rectangleXY(BLACK, -185, -130, -155, -55, NOFILL);
	GP142_rectangleXY(PURPLE, -184, -129, -156, -56, FILL);
	GP142_circleXY(BLACK, -160, -93, 3);
	GP142_rectangleXY(ICE_BLUE, -145, -75, -109, -39, FILL);
	GP142_rectangleXY(BLACK, -145, -75, -109, -39, NOFILL);
	GP142_lineXY(BLACK, -127, -75, -127, -39, 1);
	GP142_lineXY(BLACK, -145, -57, -109, -57, 1);
}

/* draw the ending screen which is breaking */
void ending(int *quit)
{
	int i,j;
	environment();
	GP142_rectangleXY(BLUE, 90, -149, 140, -49, FILL);
	GP142_rectangleXY(ICE_BLUE, 95, -85, 135, -55, FILL);
	GP142_circleXY(BLACK, 115, -100, 7);
	GP142_lineXY(BLACK, 115, -107, 115, -137, 1);
	GP142_lineXY(BLACK, 115, -137, 105, -150, 1);
	GP142_lineXY(BLACK, 115, -137, 125, -150, 1);
	GP142_lineXY(BLACK, 103, -118, 128, -118, 1);
	GP142_printfXY(BLACK, -110, -250, 50,
		"WHAT!!!!!");
	GP142_lineXY(BLACK, 115, -40, 115, 0, 1);
	GP142_lineXY(BLACK, 115, -40, 100, -25, 1);
	GP142_lineXY(BLACK, 115, -40, 130, -25, 1);
	GP142_printfXY(BLACK, 65, 0, 20, "Card Maker");
	mouse_wait();
	j=5;
	for(i=1;i<=20;i++){
		if(j==5) j=0;
		else j=5;
		GP142_rectangleXY(BLACK,-GP142_XMAX,-GP142_YMAX,
						GP142_XMAX,GP142_YMAX,FILL);
		GP142_printfXY(YELLOW,-70,130 - j,40,
			"SORRY");
		GP142_printfXY(YELLOW,-130,30 - j,40,
			"OUT OF PAPER");
		GP142_printfXY(YELLOW,-200,-70 - j, 40,
			"SO CLICK ANYWHERE");
		GP142_printfXY(YELLOW,-150,-170 - j, 40,
			"TO QUIT MAKING");
		if (i==1)
			mouse_wait();

		GP142_circleXY(WHITE, 0 , 0 - j, 120);
		if (i==20){
			GP142_lineXY(WHITE, -120, GP142_YMAX, -140, 150, 1);
			GP142_lineXY(WHITE, -140, 150, -70, 170, 1);
			GP142_lineXY(WHITE, -70, 170, -90, 80, 1);
			GP142_lineXY(WHITE, 40, -100, 20, -200,1);
			GP142_lineXY(WHITE, 20, -200, 60, -180,1);
			GP142_lineXY(WHITE, 60, -180, 40, -GP142_YMAX, 1);
			GP142_lineXY(WHITE, GP142_XMAX, GP142_YMAX, 200, 100, 1);
			GP142_lineXY(WHITE, 200, 100, 170, 150, 1);
			GP142_lineXY(WHITE, 170, 150, 100, 50, 1);
			GP142_lineXY(WHITE, -30, -30, -150, -150, 1);
			GP142_lineXY(WHITE, -150, -150, -160, -50, 1);
			GP142_lineXY(WHITE, -160, -50, -GP142_XMAX, -GP142_YMAX, 1);
		}
		if (i==20)
			mouse_wait();
		else GP142_flush();
	}
	environment();
	GP142_rectangleXY(BLUE, 0, -149, 100, -124, FILL);
	GP142_rectangleXY(BLUE, 130, -149, 230, -124, FILL);
	GP142_rectangleXY(ICE_BLUE, 6, -144, 46, -124, FILL);
	GP142_rectangleXY(ICE_BLUE, 224, -144, 184, -124, FILL);
	GP142_circleXY(BLACK, 115, -100, 7);
	GP142_lineXY(BLACK, 115, -107, 115, -137, 1);
	GP142_lineXY(BLACK, 115, -137, 105, -150, 1);
	GP142_lineXY(BLACK, 115, -137, 125, -150, 1);
	GP142_lineXY(BLACK, 103, -118, 128, -118, 1);
	GP142_printfXY(BLACK, -140, -245, 25, 
		"Making a card is a bad idea!");
	mouse_wait();
	*quit = TRUE;
}
